/* 
 * SimCoupe : Copyright (c) Allan Skillman 1996.
 *
 * audio enhancements:
 * copyright(c) Aley Keprt, 1999
 * this version uses SAAemu 0.50 or compatible
 *
 * File audio.c	- DOS interface to Aley Keprt's SAA emulator TSR
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */


#include <stdio.h> 
#include <string.h>
#include <stdlib.h>

#include <dpmi.h>
#include <sys/movedata.h>

extern "C" {
#include "z80.h"
#include "sam.h"
#include "util.h"

#include "audio.h"
}

#include "SAAemu.h"


#define DEFAULT_DEVICE DEV_OPL3


static SaaEmul saa;


unsigned char* AudioInit(void) {
//
//initializes SAA emulator and sound device
//
//return: pointer to SAA registers
//
 if(saa.Init(DEFAULT_DEVICE,0/*port*/)) {
  simcoupe_mesg(SIMCOUPE_INFO,"Audio: Couldn't initialize Aley's SAAemu");
 } else {
  simcoupe_mesg(SIMCOUPE_INFO,"Audio: Aley's SAAemu initialized");

  //get info
  simcoupe_mesg(SIMCOUPE_INFO,"Audio: %s, version: %X.%02X",
   saa.GetName(),saa.SAAtab.ver/256,saa.SAAtab.ver&0xff);
  simcoupe_mesg(SIMCOUPE_INFO,"Audio: %s, %i modes",
   saa.DeviceName(),saa.SAAtab.maxmodes);
  simcoupe_mesg(SIMCOUPE_INFO,"Audio: lowest compatible version: %X.%02X",
   saa.SAAtab.oldver/256,saa.SAAtab.oldver&0xff);

  //reset sound device
  saa.Reset();
 }

 return saa.SAAtab.reg;
}


void AudioClose(void) {
//
//closes SAA emulator
//
 simcoupe_mesg(SIMCOUPE_INFO, "Audio: Closing down SAAemu");
 saa.Reset();
 saa.Close();
}


void sdReset(void) {
 saa.Reset();
}


void sdUpdate(void) {
 saa.UpdateSound();
}

